DIR_UNKNOWN = 1
DIR_APPROACHING = 2
DIR_RECEDING = 3


class Fact:
    def __init__(self, args_jnode, args_store, arch_files, feed_files):
        """
        :type args_jnode: dict
        :type args_store: str
        :type arch_files: list[dict]
        :type feed_files: dict
        """
        self.jnode = args_jnode
        self.args_store = args_store
        self.arch_files = arch_files
        self.feed_files = feed_files

    @staticmethod
    def unpack(args_name, args_jnode):
        """
        :type args_name: str

        :param args_jnode: args.json#/
        :type args_jnode: dict

        :rtype: Fact
        :raise ValueError:
        """
        feed_files = {}
        arch_files = args_jnode['dist']
        args_blob_ref = args_name.split('-')[-1]

        for f in arch_files:
            altref = f.get('altref')
            if altref:
                # skip args.sign and args.crt
                if any(substring in altref for substring in ['.crt', '.sign']):
                    continue
                feed_files[altref.split('.')[0]] = f['ref']

        bs_chan = args_blob_ref.split('_')[0]
        return Fact(args_jnode['args'], bs_chan, arch_files, feed_files)
