#!/bin/bash

. /opt/edge/rc.setenv 

wd=/opt/edge/libexec/report
dd=/var/opt/edge/report/crossing

a=(`date +"%Y %m %d %H"`)
year=${a[0]}
month=${a[1]}
day=${a[2]}
hour=${a[3]}

mkdir -p "$dd/$year/$month/$day/"
vpth="$dd/$year/$month/$day/$hour.html"
vtmp=`mktemp`

$wd/mkreport.py $year $month $day $hour > $vtmp

if [[ -z "$(du --threshold=8k $vtmp)" ]];
then
    logger -p daemon.warning -t ${0##*/}[$$] Hour report is empty
    rm -f $vtmp
else
    mv $vtmp $vpth
    chmod 666 $vpth
fi




