from edge import eventlog
from edge.image.jnode.types import JsonImEngineArgs
from edge.types import JnodeError

from ..types import DetectorArgs


class JsonDetectorArgs(DetectorArgs):
    def __init__(self, *args, **kwargs):
        DetectorArgs.__init__(self, *args, **kwargs)

    @staticmethod
    def deserialize(jnode, def_footer_mapping):
        """
        :type jnode: dict
        :type def_footer_mapping: dict
        :rtype: JsonDetectorArgs
        :raise JnodeError:
        """
        # deserialize #/images
        images_jnode = jnode.get('images')
        if type(images_jnode) != dict:
            eventlog.log_e('fail: #/images')
            raise JnodeError

        # deserialize #/images/best
        best_waypoint_jnode = images_jnode.get('best')
        if type(best_waypoint_jnode) != dict:
            eventlog.log_e_param('#/images/best')
            raise JnodeError

        im_engine = JsonImEngineArgs.deserialize(best_waypoint_jnode)

        # deserialize #/systest
        systest = jnode.get('systest', False)

        # deserialize #/enable-overview
        enable_overview = jnode.get('enable-overview', False)

        return JsonDetectorArgs(def_footer_mapping, im_engine, systest, enable_overview)
