
class AppError(RuntimeError):
    def __init__(self, log_entry):
        """
        :type log_entry: str
        """
        self._log = [log_entry]

    def extend(self, log_entry):
        """
        :type log_entry: str
        """
        self._log.append(log_entry)

    def foreach(self, fn):
        for entry in self._log[::-1]:  # reverse
            fn(entry)

    @property
    def log(self):
        return self._log
